Index: kernel/arch/sparc64/src/mm/sun4v/as.c
===================================================================
--- kernel/arch/sparc64/src/mm/sun4v/as.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/sparc64/src/mm/sun4v/as.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -50,5 +50,5 @@
 #include <bitops.h>
 #include <macros.h>
-#include <mem.h>
+#include <memw.h>
 
 #endif /* CONFIG_TSB */
Index: kernel/arch/sparc64/src/proc/sun4u/scheduler.c
===================================================================
--- kernel/arch/sparc64/src/proc/sun4u/scheduler.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/sparc64/src/proc/sun4u/scheduler.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -76,4 +76,6 @@
 {
 	if (THREAD->uspace) {
+		asm volatile ("flushw");
+
 		/* sample the state of the userspace window buffer */
 		THREAD->arch.uspace_window_buffer =
Index: kernel/arch/sparc64/src/proc/sun4v/scheduler.c
===================================================================
--- kernel/arch/sparc64/src/proc/sun4v/scheduler.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/sparc64/src/proc/sun4v/scheduler.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -68,4 +68,6 @@
 {
 	if (THREAD->uspace) {
+		asm volatile ("flushw");
+
 		/* sample the state of the userspace window buffer */
 		THREAD->arch.uspace_window_buffer =
Index: kernel/arch/sparc64/src/smp/sun4u/smp.c
===================================================================
--- kernel/arch/sparc64/src/smp/sun4u/smp.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/sparc64/src/smp/sun4u/smp.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -106,6 +106,5 @@
 	waking_up_mid = mid;
 
-	if (waitq_sleep_timeout(&ap_completion_wq, 1000000,
-	    SYNCH_FLAGS_NONE, NULL) == ETIMEOUT)
+	if (semaphore_down_timeout(&ap_completion_semaphore, 1000000) != EOK)
 		log(LF_ARCH, LVL_NOTE, "%s: waiting for processor (mid = %" PRIu32
 		    ") timed out", __func__, mid);
Index: kernel/arch/sparc64/src/smp/sun4v/smp.c
===================================================================
--- kernel/arch/sparc64/src/smp/sun4v/smp.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/sparc64/src/smp/sun4v/smp.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -373,6 +373,5 @@
 #endif
 
-	if (waitq_sleep_timeout(&ap_completion_wq, 10000000,
-	    SYNCH_FLAGS_NONE, NULL) == ETIMEOUT)
+	if (semaphore_down_timeout(&ap_completion_semaphore, 10000000) != EOK)
 		printf("%s: waiting for processor (cpuid = %" PRIu64 ") timed out\n",
 		    __func__, cpuid);
Index: kernel/arch/sparc64/src/sun4u/start.S
===================================================================
--- kernel/arch/sparc64/src/sun4u/start.S	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/arch/sparc64/src/sun4u/start.S	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -356,6 +356,5 @@
 	 * in the ctx global variable.
 	 */
-	set ctx, %g1
-	add %g1, CONTEXT_OFFSET_SP, %g1
+	set bootstrap_stack_top, %g1
 	ldx [%g1], %o6
 
Index: kernel/genarch/include/genarch/mm/page_ht.h
===================================================================
--- kernel/genarch/include/genarch/mm/page_ht.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/genarch/include/genarch/mm/page_ht.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -57,10 +57,10 @@
 #define PTE_EXECUTABLE(pte)  ((pte)->x != 0)
 
-extern as_operations_t as_ht_operations;
-extern page_mapping_operations_t ht_mapping_operations;
+extern const as_operations_t as_ht_operations;
+extern const page_mapping_operations_t ht_mapping_operations;
 
 extern slab_cache_t *pte_cache;
 extern hash_table_t page_ht;
-extern hash_table_ops_t ht_ops;
+extern const hash_table_ops_t ht_ops;
 
 #endif
Index: kernel/genarch/include/genarch/mm/page_pt.h
===================================================================
--- kernel/genarch/include/genarch/mm/page_pt.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/genarch/include/genarch/mm/page_pt.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -140,6 +140,6 @@
 #define PTE_EXECUTABLE(p)  PTE_EXECUTABLE_ARCH((p))
 
-extern as_operations_t as_pt_operations;
-extern page_mapping_operations_t pt_mapping_operations;
+extern const as_operations_t as_pt_operations;
+extern const page_mapping_operations_t pt_mapping_operations;
 
 extern void page_mapping_insert_pt(as_t *, uintptr_t, uintptr_t, unsigned int);
Index: kernel/genarch/src/acpi/acpi.c
===================================================================
--- kernel/genarch/src/acpi/acpi.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/genarch/src/acpi/acpi.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -43,5 +43,5 @@
 #include <mm/km.h>
 #include <log.h>
-#include <mem.h>
+#include <memw.h>
 
 #define RSDP_SIGNATURE      "RSD PTR "
Index: kernel/genarch/src/drivers/ega/ega.c
===================================================================
--- kernel/genarch/src/drivers/ega/ega.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/genarch/src/drivers/ega/ega.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -42,5 +42,5 @@
 #include <typedefs.h>
 #include <arch/asm.h>
-#include <mem.h>
+#include <memw.h>
 #include <str.h>
 #include <console/chardev.h>
Index: kernel/genarch/src/drivers/via-cuda/cuda.c
===================================================================
--- kernel/genarch/src/drivers/via-cuda/cuda.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/genarch/src/drivers/via-cuda/cuda.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -41,5 +41,5 @@
 #include <stdlib.h>
 #include <synch/spinlock.h>
-#include <mem.h>
+#include <memw.h>
 
 static irq_ownership_t cuda_claim(irq_t *irq);
Index: kernel/genarch/src/fb/fb.c
===================================================================
--- kernel/genarch/src/fb/fb.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/genarch/src/fb/fb.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -45,5 +45,5 @@
 #include <align.h>
 #include <panic.h>
-#include <mem.h>
+#include <memw.h>
 #include <config.h>
 #include <bitops.h>
@@ -633,5 +633,5 @@
 
 	instance->addr = (uint8_t *) km_map((uintptr_t) props->addr, fbsize,
-	    KM_NATURAL_ALIGNMENT, PAGE_WRITE | PAGE_NOT_CACHEABLE);
+	    KM_NATURAL_ALIGNMENT, PAGE_WRITE | PAGE_WRITE_COMBINE);
 	if (!instance->addr) {
 		LOG("Unable to map framebuffer.");
Index: kernel/genarch/src/kbrd/kbrd.c
===================================================================
--- kernel/genarch/src/kbrd/kbrd.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/genarch/src/kbrd/kbrd.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -200,5 +200,5 @@
 
 	instance->sink = sink;
-	thread_ready(instance->thread);
+	thread_start(instance->thread);
 
 	return &instance->raw;
Index: kernel/genarch/src/kbrd/kbrd_at.c
===================================================================
--- kernel/genarch/src/kbrd/kbrd_at.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/genarch/src/kbrd/kbrd_at.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -198,5 +198,5 @@
 
 	instance->sink = sink;
-	thread_ready(instance->thread);
+	thread_start(instance->thread);
 
 	return &instance->raw;
Index: kernel/genarch/src/mm/as_ht.c
===================================================================
--- kernel/genarch/src/mm/as_ht.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/genarch/src/mm/as_ht.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -53,5 +53,5 @@
 static bool ht_locked(as_t *);
 
-as_operations_t as_ht_operations = {
+const as_operations_t as_ht_operations = {
 	.page_table_create = ht_create,
 	.page_table_destroy = ht_destroy,
Index: kernel/genarch/src/mm/as_pt.c
===================================================================
--- kernel/genarch/src/mm/as_pt.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/genarch/src/mm/as_pt.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -44,5 +44,5 @@
 #include <arch/mm/as.h>
 #include <typedefs.h>
-#include <mem.h>
+#include <memw.h>
 #include <arch.h>
 
@@ -54,5 +54,5 @@
 static bool pt_locked(as_t *);
 
-as_operations_t as_pt_operations = {
+const as_operations_t as_pt_operations = {
 	.page_table_create = ptl0_create,
 	.page_table_destroy = ptl0_destroy,
Index: kernel/genarch/src/mm/page_ht.c
===================================================================
--- kernel/genarch/src/mm/page_ht.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/genarch/src/mm/page_ht.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -82,5 +82,5 @@
 
 /** Hash table operations for page hash table. */
-hash_table_ops_t ht_ops = {
+const hash_table_ops_t ht_ops = {
 	.hash = ht_hash,
 	.key_hash = ht_key_hash,
@@ -90,5 +90,5 @@
 
 /** Page mapping operations for page hash table architectures. */
-page_mapping_operations_t ht_mapping_operations = {
+const page_mapping_operations_t ht_mapping_operations = {
 	.mapping_insert = ht_mapping_insert,
 	.mapping_remove = ht_mapping_remove,
Index: kernel/genarch/src/mm/page_pt.c
===================================================================
--- kernel/genarch/src/mm/page_pt.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/genarch/src/mm/page_pt.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -47,5 +47,5 @@
 #include <typedefs.h>
 #include <arch/asm.h>
-#include <mem.h>
+#include <memw.h>
 #include <align.h>
 #include <macros.h>
@@ -58,5 +58,5 @@
 static void pt_mapping_make_global(uintptr_t, size_t);
 
-page_mapping_operations_t pt_mapping_operations = {
+const page_mapping_operations_t pt_mapping_operations = {
 	.mapping_insert = pt_mapping_insert,
 	.mapping_remove = pt_mapping_remove,
Index: kernel/genarch/src/ofw/ofw_tree.c
===================================================================
--- kernel/genarch/src/ofw/ofw_tree.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/genarch/src/ofw/ofw_tree.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -39,5 +39,5 @@
 #include <stdlib.h>
 #include <sysinfo/sysinfo.h>
-#include <mem.h>
+#include <memw.h>
 #include <str.h>
 #include <panic.h>
Index: kernel/genarch/src/srln/srln.c
===================================================================
--- kernel/genarch/src/srln/srln.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/genarch/src/srln/srln.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -156,5 +156,5 @@
 
 	instance->sink = sink;
-	thread_ready(instance->thread);
+	thread_start(instance->thread);
 
 	return &instance->raw;
Index: kernel/generic/common
===================================================================
--- kernel/generic/common	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ kernel/generic/common	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,1 @@
+../../common
Index: kernel/generic/include/arch.h
===================================================================
--- kernel/generic/include/arch.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/arch.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -75,4 +75,5 @@
 typedef struct {
 	size_t preemption;      /**< Preemption disabled counter and flag. */
+	size_t mutex_locks;
 	struct thread *thread;  /**< Current thread. */
 	struct task *task;      /**< Current task. */
Index: kernel/generic/include/atomic.h
===================================================================
--- kernel/generic/include/atomic.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/atomic.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -40,4 +40,14 @@
 #include <stdatomic.h>
 
+/*
+ * Shorthand for relaxed atomic read/write, something that's needed to formally
+ * avoid undefined behavior in cases where we need to read a variable in
+ * different threads and we don't particularly care about ordering
+ * (e.g. statistic printouts). This is most likely translated into the same
+ * assembly instructions as regular read/writes.
+ */
+#define atomic_set_unordered(var, val) atomic_store_explicit((var), (val), memory_order_relaxed)
+#define atomic_get_unordered(var) atomic_load_explicit((var), memory_order_relaxed)
+
 #define atomic_predec(val) \
 	(atomic_fetch_sub((val), 1) - 1)
@@ -63,4 +73,95 @@
 	    (new_val), memory_order_relaxed)
 
+#if __64_BITS__
+
+typedef struct {
+	atomic_uint_fast64_t value;
+} atomic_time_stat_t;
+
+#define ATOMIC_TIME_INITIALIZER() (atomic_time_stat_t) {}
+
+static inline void atomic_time_increment(atomic_time_stat_t *time, int a)
+{
+	/*
+	 * We require increments to be synchronized with each other, so we
+	 * can use ordinary reads and writes instead of a more expensive atomic
+	 * read-modify-write operations.
+	 */
+	uint64_t v = atomic_load_explicit(&time->value, memory_order_relaxed);
+	atomic_store_explicit(&time->value, v + a, memory_order_relaxed);
+}
+
+static inline uint64_t atomic_time_read(atomic_time_stat_t *time)
+{
+	return atomic_load_explicit(&time->value, memory_order_relaxed);
+}
+
+#else
+
+/**
+ * A monotonically increasing 64b time statistic.
+ * Increments must be synchronized with each other (or limited to a single
+ * thread/CPU), but reads can be performed from any thread.
+ *
+ */
+typedef struct {
+	uint64_t true_value;
+	atomic_uint_fast32_t high1;
+	atomic_uint_fast32_t high2;
+	atomic_uint_fast32_t low;
+} atomic_time_stat_t;
+
+#define ATOMIC_TIME_INITIALIZER() (atomic_time_stat_t) {}
+
+static inline void atomic_time_increment(atomic_time_stat_t *time, int a)
+{
+	/*
+	 * On 32b architectures, we can't rely on 64b memory reads/writes being
+	 * architecturally atomic, but we also don't want to pay the cost of
+	 * emulating atomic reads/writes, so instead we split value in half
+	 * and perform some ordering magic to make sure readers always get
+	 * consistent value.
+	 */
+
+	/* true_value is only used by the writer, so this need not be atomic. */
+	uint64_t val = time->true_value;
+	uint32_t old_high = val >> 32;
+	val += a;
+	uint32_t new_high = val >> 32;
+	time->true_value = val;
+
+	/* Tell GCC that the first branch is far more likely than the second. */
+	if (__builtin_expect(old_high == new_high, 1)) {
+		/* If the high half didn't change, we need not bother with barriers. */
+		atomic_store_explicit(&time->low, (uint32_t) val, memory_order_relaxed);
+	} else {
+		/*
+		 * If both halves changed, extra ordering is necessary.
+		 * The idea is that if reader reads high1 and high2 with the same value,
+		 * it is guaranteed that they read the correct low half for that value.
+		 *
+		 * This is the same sequence that is used by userspace to read clock.
+		 */
+		atomic_store_explicit(&time->high1, new_high, memory_order_relaxed);
+		atomic_store_explicit(&time->low, (uint32_t) val, memory_order_release);
+		atomic_store_explicit(&time->high2, new_high, memory_order_release);
+	}
+}
+
+static inline uint64_t atomic_time_read(atomic_time_stat_t *time)
+{
+	uint32_t high2 = atomic_load_explicit(&time->high2, memory_order_acquire);
+	uint32_t low = atomic_load_explicit(&time->low, memory_order_acquire);
+	uint32_t high1 = atomic_load_explicit(&time->high1, memory_order_relaxed);
+
+	if (high1 != high2)
+		low = 0;
+
+	/* If the values differ, high1 is always the newer value. */
+	return (uint64_t) high1 << 32 | (uint64_t) low;
+}
+
+#endif /* __64_BITS__ */
+
 #endif
 
Index: kernel/generic/include/cc.h
===================================================================
--- kernel/generic/include/cc.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/cc.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -38,10 +38,7 @@
 
 #ifndef __clang__
-#define ATTRIBUTE_OPTIMIZE(opt) \
-	__attribute__ ((optimize(opt)))
 #define ATTRIBUTE_USED \
 	__attribute__ ((used))
 #else
-#define ATTRIBUTE_OPTIMIZE(opt)
 #define ATTRIBUTE_USED
 #endif
Index: kernel/generic/include/config.h
===================================================================
--- kernel/generic/include/config.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/config.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -87,9 +87,4 @@
 	size_t kernel_size;
 
-	/** Base adddress of initial stack. */
-	uintptr_t stack_base;
-	/** Size of initial stack. */
-	size_t stack_size;
-
 	bool identity_configured;
 	/** Base address of the kernel identity mapped memory. */
Index: kernel/generic/include/console/chardev.h
===================================================================
--- kernel/generic/include/console/chardev.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/console/chardev.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -39,5 +39,5 @@
 #include <stdbool.h>
 #include <stddef.h>
-#include <synch/waitq.h>
+#include <synch/semaphore.h>
 #include <synch/spinlock.h>
 
@@ -64,5 +64,5 @@
 typedef struct indev {
 	const char *name;
-	waitq_t wq;
+	semaphore_t wq;
 
 	/** Protects everything below. */
Index: kernel/generic/include/console/console.h
===================================================================
--- kernel/generic/include/console/console.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/console/console.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -69,6 +69,4 @@
 SPINLOCK_EXTERN(kio_lock);
 
-extern char32_t getc(indev_t *indev);
-extern size_t gets(indev_t *indev, char *buf, size_t buflen);
 extern sys_errno_t sys_kio(int cmd, uspace_addr_t buf, size_t size);
 
Index: kernel/generic/include/context.h
===================================================================
--- kernel/generic/include/context.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/context.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -36,6 +36,8 @@
 #define KERN_CONTEXT_H_
 
+#include <panic.h>
 #include <trace.h>
 #include <arch/context.h>
+#include <arch/faddr.h>
 
 #define context_set_generic(ctx, _pc, stack, size) \
@@ -47,35 +49,4 @@
 extern int context_save_arch(context_t *ctx) __attribute__((returns_twice));
 extern void context_restore_arch(context_t *ctx) __attribute__((noreturn));
-
-/** Save register context.
- *
- * Save the current register context (including stack pointer) to a context
- * structure. A subsequent call to context_restore() will return to the same
- * address as the corresponding call to context_save().
- *
- * Note that context_save_arch() must reuse the stack frame of the function
- * which called context_save(). We guarantee this by:
- *
- *   a) implementing context_save_arch() in assembly so that it does not create
- *      its own stack frame, and by
- *   b) defining context_save() as a macro because the inline keyword is just a
- *      hint for the compiler, not a real constraint; the application of a macro
- *      will definitely not create a stack frame either.
- *
- * To imagine what could happen if there were some extra stack frames created
- * either by context_save() or context_save_arch(), we need to realize that the
- * sp saved in the contex_t structure points to the current stack frame as it
- * existed when context_save_arch() was executing. After the return from
- * context_save_arch() and context_save(), any extra stack frames created by
- * these functions will be destroyed and their contents sooner or later
- * overwritten by functions called next. Any attempt to restore to a context
- * saved like that would therefore lead to a disaster.
- *
- * @param ctx Context structure.
- *
- * @return context_save() returns 1, context_restore() returns 0.
- *
- */
-#define context_save(ctx)  context_save_arch(ctx)
 
 /** Restore register context.
@@ -91,7 +62,37 @@
  *
  */
-_NO_TRACE static inline void context_restore(context_t *ctx)
+_NO_TRACE __attribute__((noreturn))
+    static inline void context_restore(context_t *ctx)
 {
 	context_restore_arch(ctx);
+}
+
+/**
+ * Saves current context to the variable pointed to by `self`,
+ * and restores the context denoted by `other`.
+ *
+ * When the `self` context is later restored by another call to
+ * `context_swap()`, the control flow behaves as if the earlier call to
+ * `context_swap()` just returned.
+ */
+_NO_TRACE static inline void context_swap(context_t *self, context_t *other)
+{
+	if (context_save_arch(self))
+		context_restore_arch(other);
+}
+
+_NO_TRACE static inline void context_create(context_t *context,
+    void (*fn)(void), void *stack_base, size_t stack_size)
+{
+	*context = (context_t) { 0 };
+	context_set(context, FADDR(fn), stack_base, stack_size);
+}
+
+__attribute__((noreturn)) static inline void context_replace(void (*fn)(void),
+    void *stack_base, size_t stack_size)
+{
+	context_t ctx;
+	context_create(&ctx, fn, stack_base, stack_size);
+	context_restore(&ctx);
 }
 
Index: kernel/generic/include/cpu.h
===================================================================
--- kernel/generic/include/cpu.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/cpu.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -44,5 +44,39 @@
 #include <arch.h>
 
-#define CPU                  CURRENT->cpu
+#define CPU                  (CURRENT->cpu)
+#define CPU_LOCAL            (&CPU->local)
+
+/**
+ * Contents of CPU_LOCAL. These are variables that are only ever accessed by
+ * the CPU they belong to, so they don't need any synchronization,
+ * just locally disabled interrupts.
+ */
+typedef struct cpu_local {
+	/**
+	 * When system clock loses a tick, it is
+	 * recorded here so that clock() can react.
+	 */
+	size_t missed_clock_ticks;
+
+	uint64_t current_clock_tick;
+	uint64_t preempt_deadline;  /* < when should the currently running thread be preempted */
+	uint64_t relink_deadline;
+
+	/**
+	 * Stack used by scheduler when there is no running thread.
+	 * This field is unchanged after initialization.
+	 */
+	uint8_t *stack;
+
+	/**
+	 * Processor cycle accounting.
+	 */
+	bool idle;
+	uint64_t last_cycle;
+
+	context_t scheduler_context;
+
+	struct thread *prev_thread;
+} cpu_local_t;
 
 /** CPU structure.
@@ -51,14 +85,11 @@
  */
 typedef struct cpu {
-	IRQ_SPINLOCK_DECLARE(lock);
+	IRQ_SPINLOCK_DECLARE(tlb_lock);
 
 	tlb_shootdown_msg_t tlb_messages[TLB_MESSAGE_QUEUE_LEN];
 	size_t tlb_messages_count;
 
-	context_t saved_context;
-
 	atomic_size_t nrdy;
 	runq_t rq[RQ_COUNT];
-	volatile size_t needs_relink;
 
 	IRQ_SPINLOCK_DECLARE(timeoutlock);
@@ -66,19 +97,8 @@
 
 	/**
-	 * When system clock loses a tick, it is
-	 * recorded here so that clock() can react.
-	 * This variable is CPU-local and can be
-	 * only accessed when interrupts are
-	 * disabled.
-	 */
-	size_t missed_clock_ticks;
-
-	/**
 	 * Processor cycle accounting.
 	 */
-	bool idle;
-	uint64_t last_cycle;
-	uint64_t idle_cycles;
-	uint64_t busy_cycles;
+	atomic_time_stat_t idle_cycles;
+	atomic_time_stat_t busy_cycles;
 
 	/**
@@ -95,10 +115,11 @@
 	cpu_arch_t arch;
 
-	struct thread *fpu_owner;
+#ifdef CONFIG_FPU_LAZY
+	/* For synchronization between FPU trap and thread destructor. */
+	IRQ_SPINLOCK_DECLARE(fpu_lock);
+#endif
+	_Atomic(struct thread *) fpu_owner;
 
-	/**
-	 * Stack used by scheduler when there is no running thread.
-	 */
-	uint8_t *stack;
+	cpu_local_t local;
 } cpu_t;
 
Index: kernel/generic/include/cpu/cpu_mask.h
===================================================================
--- kernel/generic/include/cpu/cpu_mask.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/cpu/cpu_mask.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -37,5 +37,5 @@
 #include <cpu.h>
 #include <config.h>
-#include <lib/memfnc.h>
+#include <memw.h>
 
 /** Iterates over all cpu id's whose bit is included in the cpu mask.
Index: kernel/generic/include/debug.h
===================================================================
--- kernel/generic/include/debug.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/debug.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -37,7 +37,13 @@
 
 #include <log.h>
-#include <symtab_lookup.h>
+#include <printf/verify.h>
 
 #define CALLER  ((uintptr_t) __builtin_return_address(0))
+
+/* An empty printf function to ensure syntactic correctness of disabled debug prints. */
+static inline void dummy_printf(const char *fmt, ...) _HELENOS_PRINTF_ATTRIBUTE(1, 2);
+static inline void dummy_printf(const char *fmt, ...)
+{
+}
 
 #ifdef CONFIG_LOG
@@ -53,5 +59,5 @@
 	do { \
 		log(LF_OTHER, LVL_DEBUG, \
-		    "%s() from %s at %s:%u: " format,__func__, \
+		    "%s() from %s at %s:%u: " format, __func__, \
 		    symtab_fmt_name_lookup(CALLER), __FILE__, __LINE__, \
 		    ##__VA_ARGS__); \
@@ -60,5 +66,5 @@
 #else /* CONFIG_LOG */
 
-#define LOG(format, ...)
+#define LOG(format, ...) dummy_printf(format, ##__VA_ARGS__)
 
 #endif /* CONFIG_LOG */
